<?php

/**
 * graf_etapas actions.
 *
 * @package    canon
 * @subpackage graf_etapas
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class graf_etapasActions extends sfQuery {

    /**
     * Metodo list de accesos
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }


            /*
             * variables de filtro
             */

            $whereModulo = ' ';
            if (isset($request['id_modulo'])) {
                $whereModulo = " AND tab1.id_modulo = '" . $request['id_modulo'] . "' ";
            }

            $grafica = '0';
            if (isset($request['grafica'])) {
                $grafica = $request['grafica'];
            }

            //Numero titulos activos actualmente por etapa
            if ($grafica == 1) {
                //  $con= "select table1.*, tab1.nombre from (select count(*) as count, id_etapa, estado from ca_titulo_etapa where actual=1  group by id_etapa, estado)table1 join ca_etapa tab1 on table1.id_etapa =tab1.id_etapa order by estado";

                $con = "
SELECT vigencia, wm_concat(id_etapa) as id_etapa, wm_concat(nombre) as nombre, wm_concat(count) as count
from
(select table1.*, tab1.nombre from (select vigencia, id_etapa , sum(total) as count
from (
select to_char(a.FECHA_INICIO, 'yyyy') as vigencia ,  count(*) as total, t.id_etapa
from ca_titulo_etapa t join ca_anual_etapa a
on a.id_titulo_etapa = t.id_titulo_etapa and t.actual = 1 and t.estado=1 and a.estado = 1
group by t.id_etapa , a.FECHA_INICIO)
group by vigencia, id_etapa
order by vigencia)table1 join ca_etapa tab1 on table1.id_etapa =tab1.id_etapa )
where vigencia>2000
group by vigencia";
            }
            //Numero de titulos activos actualmente por competencia
            else if ($grafica == 2) {
                $con = "select table1.*, tab3.nombre from (select count(*) as count, id_competencia from ca_titulo_etapa tab0 join in_titulo_competencia tab1 on tab0.id_titulo=tab1.id_titulo where tab0.actual=1 and tab0.estado=1 and tab1.actual=1 group by id_competencia)table1 join rmn_competencia tab3 on table1.id_competencia =tab3.id_competencia";
            }
            //Numero de titulos activos actualmente por competencia discriminados por etapa
            else if ($grafica == 3) {
                $con = "
select nombre, wm_concat(id_etapa) as id_etapa, wm_concat(count) as count
from(select 
tab3.nombre, 
table1.*
from (
select  
id_competencia, 
id_etapa,
count(*) as count
from ca_titulo_etapa tab0 
join in_titulo_competencia tab1 on tab0.id_titulo=tab1.id_titulo 
where tab0.actual=1 
and tab0.estado=1 
and tab1.actual=1 
group by id_competencia, id_etapa)table1 
join rmn_competencia tab3 on table1.id_competencia =tab3.id_competencia
where tab3.num_doc='8999992948')
group by nombre";
            }
            //Area total de titulos por competencia
            else if ($grafica == 4) {
                $con = "select count(*) from  in_titulo_competencia tab0 join in_titulo_area  tab1  on tab0.id_titulo=tab1.id_titulo where tab1.actual=1 and tab1.estado=1 and tab0.actual=1 group by id_competencia";
            }




            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from(
 
$con

)tabla

EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];

            //validar si hay registros
            if ($total_record_count > 0) {

                /*
                 * Obtiene los accesos para un perfil
                 */
                $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
      
    $con
            
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;

                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);

                // Solo registra log la primera vez de consulta
                if ($rowStart == 0) {
                    //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                    $id_ope_bd = 1;
                    //obtener id maestro tabla
                    $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_titulo_etapa');
                    //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                    $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
                }

                $this->totalRows = $total_record_count;
                $this->startRow = $rowStart;
                $this->endRow = $rowEnd;
                $this->status = 0;
                $this->list_data = $records;
                $this->logMessage("[GRAF_ETAPAS] Consulta exitosa.");
            } else {

                $mensaje = "[GRAF_ETAPAS] No hay registros de consulta.";
                $this->status = 1;
                $this->mensajeError = $mensaje;
                $this->list_data = array();
                $this->logMessage($mensaje);
            }
        } catch (Exception $e) {
            $error = "[GRAF_ETAPAS] ERROR: " . $e->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
    }

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
